## This Sagemath program creates two files: 'fplot.txt' and 'nodes.txt'.
## These files can be used in a LaTeX file with TikZ package.

def mylinspace(a, b, npoints):
   return [a + (b - a) * 1.0 * j / (npoints - 1) for j in range(npoints)]

def savefunvalues(fname, fun, xvector):
   s = ''.join(['%.5f %.5f\n' % (x, fun(x)) for x in xvector])
   with open(fname, 'w') as myfile:
      myfile.write(s)

def f1(x):
   return 1.2 * exp(- 0.04 * x ^ 2) * cos(2 * x + 0.4)

savefunvalues('fplot.txt', f1, mylinspace(-2, 2, 401))
savefunvalues('nodes.txt', f1, [-2.0, -1.6, -0.8, -0.1, 0.3, 0.5, 1.1, 2])

